byte numRows=4;
int bottomPaddle;
int bottomPaddleWidth;
int bottomPaddleOld;
int ballX;
int ballY;
int  ballDirX;
int ballDirY;
byte loopCount=false;


void breakout_loop()
{
  if (!(PINC & 0x02)) bottomPaddle--;  // PORT C pin 1 is attached to left button
  if (!(PINC & 0x10)) bottomPaddle++;  // PORT C pin 4 is attached to right button
  if (bottomPaddle < gameMinX) bottomPaddle = gameMinX;
  if (bottomPaddle > gameMaxX) bottomPaddle = gameMaxX;

  if (loopCount) {
    breakout_move_ball();
  }
  loopCount=!loopCount;
  breakout_draw_paddles();
  refresh_display(speed);
}

void breakout_setup_game()
{
  clear_display();
  add_wall(gameMinX,gameMinY,gameMinX,gameMaxY);
  add_wall(gameMaxX,gameMinY,gameMaxX,gameMaxY);
  add_wall(gameMinX,gameMinY,gameMaxX,gameMinY);
  for (byte x=gameMinX+1;x< gameMaxX; x++) {
    for (byte y=gameMinY;y<=(numRows-gameMinY);y++) {
      setPixel(x,y,7);
    }
  }
  bottomPaddle=gameCentreX;
  bottomPaddleWidth=5;
  bottomPaddleOld=0;
  ballX=gameCentreX;
  ballY=gameMaxY-1;
  ballDirX=0;
  ballDirY=-1;
  breakout_draw_paddles();
  speed=10;
}

void breakout_draw_paddles()
{
  if (bottomPaddleOld != bottomPaddle) {
    for (byte i=0;i<bottomPaddleWidth;i++) {
      setPixel(bottomPaddleOld-(bottomPaddleWidth/2)+i,gameMaxY,0);
    }
    bottomPaddleOld=bottomPaddle;
    for (byte i=0;i<bottomPaddleWidth;i++) {
      setPixel(bottomPaddle-(bottomPaddleWidth/2)+i,gameMaxY,7);
    }
  }
}


void breakout_move_ball()
{
  byte oldBallX = ballX;
  byte oldBallY = ballY;
  ballX=ballX+ballDirX;
  ballY=ballY+ballDirY;
  if ((ballX <= (gameMinX)) || (ballX >= (gameMaxX))) {
    ballDirX=-ballDirX;
    ballX=ballX+ballDirX;
  }

  if (ballY <= (gameMinY+1)) {
    ballDirY=-ballDirY;
  } 
  else if (ballY >= (gameMaxY-1)) {
    if ((ballX < (bottomPaddle-(bottomPaddleWidth/2))) ||
      (ballX > (bottomPaddle-(bottomPaddleWidth/2)+bottomPaddleWidth))) { // Looks odd but needed so matches paddle image
      // Missed it!
      setPixel(ballX,ballY,7);
      breakout_setup_game();
      update_scorebar();
    } 
    else {
      if (ballX<(bottomPaddle-1)) {
        ballDirX--;
      } 
      else if (ballX>(bottomPaddle+1)) {
        ballDirX++;
      }
      ballDirY=-ballDirY;
    }
  } 
  else {
    if (ballDirY<0) {
      byte pointX=(ballX/2)*2;
      byte pointY=(ballY/2)*2;
      if (frame4.GetPoint(pointX,pointY) || 
        frame4.GetPoint(pointX+1,pointY) || 
        frame4.GetPoint(pointX,pointY-1) || 
        frame4.GetPoint(pointX+1,pointY-1) ) {
        if (pointX>gameMinX) {
          setPixel(pointX,pointY,0);
          setPixel(pointX,pointY-1,0);
        } 
        if ((pointX+1)<gameMaxX) {
          setPixel(pointX+1,pointY,0);
          setPixel(pointX+1,pointY-1,0);
        }
        points++;
        ballDirY=-ballDirY;
        update_scorebar();
      }
    }
  }
  setPixel(ballX,ballY,7);
  if ((ballX > gameMinX) && (ballX < gameMaxX) && (ballY > gameMinY)) {
    setPixel(oldBallX,oldBallY,0);
  } 
}

