// Define pong properties
byte topPaddle;
byte topPaddleOld;
byte topPaddleWidth;
byte aiPoints=0;
/* Defined in peggy2_breakout but here for reference
byte loopCount=false;
byte ballX;
byte ballY;
int ballDirX;
int ballDirY;
byte bottomPaddleWidth;
byte bottomPaddleOld;
byte bottomPaddle;
*/

void pong_draw_paddles()
{
  if (topPaddleOld != topPaddle) {
    for (byte i=0;i<topPaddleWidth;i++) {
      setPixel(topPaddleOld-(topPaddleWidth/2)+i,gameMinY,0);
    }
    topPaddleOld=topPaddle;
    for (byte i=0;i<topPaddleWidth;i++) {
      setPixel(topPaddle-(topPaddleWidth/2)+i,gameMinY,7);
    }
  }
  if (bottomPaddleOld != bottomPaddle) {
    for (byte i=0;i<bottomPaddleWidth;i++) {
      setPixel(bottomPaddleOld-(bottomPaddleWidth/2)+i,gameMaxY,0);
    }
    bottomPaddleOld=bottomPaddle;
    for (byte i=0;i<bottomPaddleWidth;i++) {
      setPixel(bottomPaddle-(bottomPaddleWidth/2)+i,gameMaxY,7);
    }
  }
}

void pong_setup_board()
{
  clear_display();
  for (byte i=gameMinX; i< gameMaxX; i++) {
    setPixel(i,gameCentreY,4);
  }
  add_wall(gameMinX,gameMinY,gameMinX,gameMaxY);
  add_wall(gameMaxX,gameMinY,gameMaxX,gameMaxY);
}

void pong_loop()
{
  if (!(PINC & 0x02)) bottomPaddle--;  // PORT C pin 1 is attached to left button
  if (!(PINC & 0x10)) bottomPaddle++;  // PORT C pin 4 is attached to right button
  if (bottomPaddle < gameMinX) bottomPaddle = gameMinX;
  if (bottomPaddle > gameMaxX) bottomPaddle = gameMaxX;
  pong_move_ai();
  
  if (loopCount) {
    pong_move_ball();
  }
  loopCount=!loopCount;
  pong_draw_paddles();
  refresh_display(speed);
}

void pong_move_ai()
{
  // Only move 2/3 of the time
  if (random(3) != 0) {
    if (ballX < topPaddle) {
      topPaddle--;
    } 
    else {
      topPaddle++;
    }
  }
}

void pong_setup_game()
{ 
  pong_setup_board();
  topPaddle=gameCentreX;
  bottomPaddle=gameCentreX;
  topPaddleOld=0;
  bottomPaddleOld=0;
  topPaddleWidth=5;
  bottomPaddleWidth=5;
  ballX=gameCentreX;
  ballY=gameCentreY;
  ballDirX=random(2);
  if (ballDirX==0) ballDirX=-1;
  ballDirY=random(2);
  if (ballDirY==0) ballDirY=-1;
  pong_draw_paddles();
  speed=10-(points*2);
}


void pong_move_ball()
{
  byte oldBallX = ballX;
  byte oldBallY = ballY;
  ballX=ballX+ballDirX;
  ballY=ballY+ballDirY;
  if ((ballX <= (gameMinX)) || (ballX >= (gameMaxX))) {
    ballDirX=-ballDirX;
    ballX=ballX+ballDirX;
  }

  if (ballY <= (gameMinY+1)) {
    ballDirY=-ballDirY;
    if ((ballX < (topPaddle-(topPaddleWidth/2))) ||
      (ballX > (topPaddle-(topPaddleWidth/2)+topPaddleWidth))) { // Looks odd but needed so matches paddle image
      // Missed it
      points++;
      setPixel(ballX,ballY,7);
      pong_display_score_update();
      pong_setup_game();
      update_scorebar();
    }
  } else if (ballY >= (gameMaxY-1)) {
    ballDirY=-ballDirY;
    if ((ballX < (bottomPaddle-(bottomPaddleWidth/2))) ||
      (ballX > (bottomPaddle-(bottomPaddleWidth/2)+bottomPaddleWidth))) { // Looks odd but needed so matches paddle image
      // Missed it!
      setPixel(ballX,ballY,7);
      aiPoints++;
      pong_display_score_update();
      pong_setup_game();
      update_scorebar();
    } else {
      if (ballX<bottomPaddle) {
        ballDirX--;
      } else if (ballX>bottomPaddle) {
        ballDirX++;
      }
    }
  }
  setPixel(ballX,ballY,7);
  if (oldBallY == gameCentreY) {
    setPixel(oldBallX,oldBallY,4);
  }  else if ((ballX == gameMinX) || (ballX == gameMaxX)) {
    setPixel(oldBallX,oldBallY,7);
  } else {
    setPixel(oldBallX,oldBallY,0);
  }
 
}

void pong_display_score_update()
{
  write_number(aiPoints,5,3,7);
  write_number(points,5,15,7);
  
  refresh_display(200);
}
